﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsFormsApp2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        /*
        LIB3DPRINTER_API Bool GetCurrent(U16 *Red,U16 *Green,U16 *Blue);
LIB3DPRINTER_API Bool ShakeHands(void);
	
LIB3DPRINTER_API Bool SetCurrent(U16 red,U16 green,U16 blue);
LIB3DPRINTER_API Bool LedOnOff(unsigned char flag);
	
LIB3DPRINTER_API int FirmWareUpGrate(U8 *FileName,U8 Namelength);
LIB3DPRINTER_API Bool GetTemperature(short int *r,short int *g,short int *b,short int *board);
LIB3DPRINTER_API Bool CheckVersion(U32 Version);
LIB3DPRINTER_API Bool Flip(unsigned char FlipX,unsigned char FlipY);
LIB3DPRINTER_API Bool InputSource(unsigned char Value);
LIB3DPRINTER_API Bool LightControl(U8 Index);
LIB3DPRINTER_API int PackageReceive(unsigned char *Buffer,unsigned char Size);
//-----------------------------------------------------------------------------------
LIB3DPRINTER_API Bool OpenUart(unsigned char dwPort,unsigned long dwBaudRate);
LIB3DPRINTER_API void CloseUart(unsigned char dwPort);
//-----------------------------------------------------------------------------------
LIB3DPRINTER_API void Delay10Ms(U16 m10s);
LIB3DPRINTER_API void Delay1Ms(U16 ms);

    */

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool CheckVersion(out UInt32 Version);


        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool LightControl(byte Index );



        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool ShakeHands();

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool LedOnOff(byte flag);

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern void OpenUart(byte dwPort, uint dwBaudRate);

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern void CloseUart(byte dwPort);

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool GetCurrent(out UInt16 Red, out UInt16 Green, out UInt16 Blue);

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool SetCurrent(UInt16 Red, UInt16 Green, UInt16 Blue);

        [DllImport("Lib3DPrinter.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool GetTemperature(out short r, out short g, out short b, out short board);


        private void btnUART_Click(object sender, EventArgs e)
        {
            OpenUart(4, 9600);
            ShakeHands();
        }

        private void btnLEDON_Click(object sender, EventArgs e)
        {
            
            LedOnOff(1);
            RefreshTemperature();
        }
        private void btnLedOff_Click(object sender, EventArgs e)
        {
            LedOnOff(0);
        }

        private void btnCloseUart_Click(object sender, EventArgs e)
        {
            CloseUart(4);
        }

        private void btnGetCurrent_Click(object sender, EventArgs e)
        {
            UInt16 red, green, blue;
            GetCurrent(out red, out green, out blue);
            txtLed.Text = green.ToString();
            RefreshTemperature();
        }

        private void btnSetCurrent_Click(object sender, EventArgs e)
        {
            UInt16 led = Convert.ToUInt16(txtLed.Value);
            SetCurrent(led, led, led);
            RefreshTemperature();
        }

        private void RefreshTemperature()
        {
            short r, g, b, board;
            GetTemperature(out r, out g, out b, out board);
            lblR.Text = r.ToString();
            lblG.Text = g.ToString();
            lblB.Text = b.ToString();
            lblBoard.Text = board.ToString();

        }

        private void btnTemperature_Click(object sender, EventArgs e)
        {
            RefreshTemperature();
        }




        private void txtLed_Click(object sender, EventArgs e)
        {
            UInt16 led = Convert.ToUInt16(txtLed.Text);
            SetCurrent(led, led, led);
            RefreshTemperature();
        }
    }
}
