
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the LIB3DPRINTER_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// LIB3DPRINTER_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifndef __LIB3DPRINTER_H__
#define __LIB3DPRINTER_H__

#ifdef LIB3DPRINTER_EXPORTS
#define LIB3DPRINTER_API __declspec(dllexport)
#else
#define LIB3DPRINTER_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

LIB3DPRINTER_API Bool GetCurrent(U16 *Red,U16 *Green,U16 *Blue);
LIB3DPRINTER_API Bool ShakeHands(void);
	
LIB3DPRINTER_API Bool SetCurrent(U16 red,U16 green,U16 blue);
LIB3DPRINTER_API Bool LedOnOff(unsigned char flag);
	
LIB3DPRINTER_API int FirmWareUpGrate(U8 *FileName,U8 Namelength);
LIB3DPRINTER_API Bool GetTemperature(short int *r,short int *g,short int *b,short int *board);
LIB3DPRINTER_API Bool CheckVersion(U32 Version);
LIB3DPRINTER_API Bool Flip(unsigned char FlipX,unsigned char FlipY);
LIB3DPRINTER_API Bool InputSource(unsigned char Value);
LIB3DPRINTER_API Bool LightControl(U8 Index);
LIB3DPRINTER_API int PackageReceive(unsigned char *Buffer,unsigned char Size);
//-----------------------------------------------------------------------------------
LIB3DPRINTER_API Bool OpenUart(unsigned char dwPort,unsigned long dwBaudRate);
LIB3DPRINTER_API void CloseUart(unsigned char dwPort);
//-----------------------------------------------------------------------------------
LIB3DPRINTER_API void Delay10Ms(U16 m10s);
LIB3DPRINTER_API void Delay1Ms(U16 ms);

#ifdef __cplusplus
}
#endif

#endif